#include "CSTree.h"

Stack stack;        // Stack. Used to store nodes

int main(int argc, char* argv[])
{
	CSTree pTree;	// ָ
	
	//
	// Initialize the stack
	//
	InitStack(&stack); 
	
	//
	// , ʹöʾ
	//
	pTree = InitTree();
	
	//
	// 
	//
	PreOrder(pTree);
	
	//
	// output result
	//	
	OutputResult();
	
	//
	// 
	//
	DeleteTree(pTree);

	return 0;
}

/*
function:
	.Stack implementation of non - recursive algorithm.

parameter:
	pTree -- ָ.
  
returned value:
	Returns 1 if the traversal succeeds
	Returns 0 if the traversal fails
*/
char g_string[MAX_NUMBER];			// ַ.ڱб
int g_length = 0;					// The string length.0 indicates an empty string
int PreOrder(CSTree pTree)
{
	CSNode* pNode;					// ڵָ
	
	//
	// TODO: Add the code here
	//	
	
	return 0;
}

/*
function:
	һڵ.

parameter:
	data -- ڵ㱣
  
returned value:
	Return node pointer
*/
CSNode* CreateNode(char data)
{
	CSNode* pNode = (CSNode*)malloc(sizeof(CSNode));
	
	pNode->data = data;
	pNode->firstchild = NULL;
	pNode->nextsibling = NULL;
	
	return pNode;
}

/*
function:
	һ.

parameter:
	data -- ڵ㱣
	pRootNode -- ָ
  
returned value:
		nothing
*/
void CreateSubTree(char* data, CSTree pRootNode)
{
	int i;
	CSTree pFirstChild;
		
	pRootNode->firstchild = CreateNode(data[1]);
	pFirstChild = pRootNode->firstchild;
		
	for(i = 2; data[i] != '\0'; i++)
	{
		pFirstChild->nextsibling = CreateNode(data[i]);
		pFirstChild = pFirstChild->nextsibling; 
	}	
}

/*
function:
	ʹ㷨.

parameter:
	CSTree -- ָ
  
returned value:
	Ϊ Key Ľڵָ
*/
CSNode* PreOrderCreate(CSTree pTree, char Key)
{
	CSNode* pNode = NULL;
	
	if(pTree != NULL)
	{	
		if(pTree->data == Key)
			return pTree;
			
		pNode = PreOrderCreate(pTree->firstchild, Key);
		if(pNode != NULL)
			return pNode;
		pNode = PreOrderCreate(pTree->nextsibling, Key);	
		if(pNode != NULL)
			return pNode;
	}

	return NULL;
}

/*
function:
	öάʼ.
  
returned value:
	ָ
*/
const char data[MAX_NUMBER][MAX_NUMBER] = 
{ { 'R', 'A', 'B', 'C' },	  	  // ڳʼĶά,άÿһйһ,
  { 'A', 'D', 'E'      },	  	  // һַڳʼĸڵ,ڶַڳʼ
  { 'C', 'F'    	   },	      // ӽڵ,ַڳʼֵܽڵ.notice:һ
  { 'F', 'G', 'H', 'K' } };		  // еĵһַڹĸڵ,еĵһ
						 		  // ַӦΪ֮ǰĳһеĺӽڵֵܽڵ.

CSTree InitTree()
{	
	int i = 0;
	CSNode* pNode = NULL;
	CSTree pRootNode = CreateNode(data[0][0]); 
	
	for(i = 0; data[i][0] != 0; i++)
	{
		pNode = PreOrderCreate(pRootNode, data[i][0]);	
		CreateSubTree((char*)data[i], pNode);
	}
	
	return pRootNode;
}

/*
function:
	.

parameter:
	pTree -- ָ.
  
returned value:
	nothing
*/
void DeleteTree(CSTree pTree)
{
	//
	// The sequential traversal algorithm is implemented by recursion
	//
	if(pTree != NULL)
	{	
		DeleteTree(pTree->firstchild);
		DeleteTree(pTree->nextsibling);
		
		free(pTree);
	}
}

/*
function:
	output result.

parameter:
	nothing
  
returned value:
	nothing
*/
void OutputResult()
{
	int i;
	for(i = 0; i < g_length - 1; i++)
	{
		printf("%c", g_string[i]);
	} 
	printf("\n");
}

